/*
 Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na
              tabela MENUGRUPOP
 Objetivo: Gerar um log que vai registrar as alteraes na tabela MENUGRUPOP, utilizando
             a tabela Geral de Logs de Operaes */

CREATE OR REPLACE TRIGGER LOG_GER_MENUGRUPOP
AFTER DELETE OR INSERT OR UPDATE
ON MENUGRUPOP FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_DTOPER       DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   IF DELETING THEN
      IF :OLD.CDGRUPOPER IS NOT NULL THEN
         V_DESC := V_DESC || 'Oper=' || :OLD.CDGRUPOPER;
      END IF;

      IF :OLD.CDSISTGRUP IS NOT NULL THEN
         V_DESC := V_DESC || ' SisOper=' || :OLD.CDSISTGRUP;
      END IF;

      IF :OLD.CDMENUITGRUP IS NOT NULL THEN
         V_DESC := V_DESC || ' MnItOper=' || :OLD.CDMENUITGRUP;
      END IF;

      IF :OLD.DSCAPTIONGRU IS NOT NULL THEN
         V_DESC := V_DESC || ' DsCaptOper=' || :OLD.DSCAPTIONGRU;
      END IF;

      IF :OLD.DSBPLGRUP IS NOT NULL THEN
         V_DESC := V_DESC || ' DSBPLGRUP=' || :OLD.DSBPLGRUP;
      END IF;

      IF :OLD.NRTPMENUGRUP IS NOT NULL THEN
         V_DESC := V_DESC || ' TpMenuOper=' || :OLD.NRTPMENUGRUP;
      END IF;

      IF :OLD.NRATALHOGRUP IS NOT NULL THEN
         V_DESC := V_DESC || ' AtaOper=' || :OLD.NRATALHOGRUP;
      END IF;

      IF :OLD.NRNIVELGRUP IS NOT NULL THEN
         V_DESC := V_DESC || ' NivOper=' || :OLD.NRNIVELGRUP;
      END IF;

      IF :OLD.NRPOSBOTGRUP IS NOT NULL THEN
         V_DESC := V_DESC || ' PosBotOper=' || :OLD.NRPOSBOTGRUP;
      END IF;

      IF :OLD.NRMENUGRGRUP IS NOT NULL THEN
         V_DESC := V_DESC || ' NrMenu=' || :OLD.NRMENUGRGRUP;
      END IF;
      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDGRUPOPER||:OLD.CDSISTGRUP||:OLD.CDMENUITGRUP;
   ELSE
      IF UPDATING THEN
         IF (NVL(:OLD.CDGRUPOPER,'')   <> NVL(:NEW.CDGRUPOPER,''))   OR
            (NVL(:OLD.CDSISTGRUP,'')   <> NVL(:NEW.CDSISTGRUP,''))   OR
            (NVL(:OLD.CDMENUITGRUP,'') <> NVL(:NEW.CDMENUITGRUP,'')) OR
            (NVL(:OLD.DSCAPTIONGRU,'') <> NVL(:NEW.DSCAPTIONGRU,'')) OR
            (NVL(:OLD.DSBPLGRUP,'')    <> NVL(:NEW.DSBPLGRUP,''))    OR
            (NVL(:OLD.NRTPMENUGRUP,'') <> NVL(:NEW.NRTPMENUGRUP,'')) OR
            (NVL(:OLD.NRATALHOGRUP,'') <> NVL(:NEW.NRATALHOGRUP,'')) OR
            (NVL(:OLD.NRNIVELGRUP,'')  <> NVL(:NEW.NRNIVELGRUP,''))  OR
            (NVL(:OLD.NRPOSBOTGRUP,'') <> NVL(:NEW.NRPOSBOTGRUP,'')) OR
            (NVL(:OLD.NRMENUGRGRUP,'') <> NVL(:NEW.NRMENUGRGRUP,'')) THEN

            IF NVL(:OLD.CDGRUPOPER,'') <> NVL(:NEW.CDGRUPOPER,'') THEN
               V_DESC := V_DESC || 'Oper=' || :NEW.CDGRUPOPER;
            END IF;

            IF NVL(:OLD.CDSISTGRUP,'') <> NVL(:NEW.CDSISTGRUP,'') THEN
               V_DESC := V_DESC || ' SisOper=' || :NEW.CDSISTGRUP;
            END IF;

            IF NVL(:OLD.CDMENUITGRUP,'') <> NVL(:NEW.CDMENUITGRUP,'') THEN
               V_DESC := V_DESC || ' MnItOper=' || :NEW.CDMENUITGRUP;
            END IF;

            IF NVL(:OLD.DSCAPTIONGRU,'') <> NVL(:NEW.DSCAPTIONGRU,'') THEN
               V_DESC := V_DESC || ' DsCaptOper=' || :NEW.DSCAPTIONGRU;
            END IF;

            IF NVL(:OLD.DSBPLGRUP,'') <> NVL(:NEW.DSBPLGRUP,'') THEN
               V_DESC := V_DESC || ' DSBPLGRUP=' || :NEW.DSBPLGRUP;
            END IF;

            IF NVL(:OLD.NRTPMENUGRUP,'') <> NVL(:NEW.NRTPMENUGRUP,'') THEN
               V_DESC := V_DESC || ' TpMenuOper=' || :NEW.NRTPMENUGRUP;
            END IF;

            IF NVL(:OLD.NRATALHOGRUP,'') <> NVL(:NEW.NRATALHOGRUP,'') THEN
               V_DESC := V_DESC || ' AtaOper=' || :NEW.NRATALHOGRUP;
            END IF;

            IF NVL(:OLD.NRNIVELGRUP,'') <> NVL(:NEW.NRNIVELGRUP,'') THEN
               V_DESC := V_DESC || ' NivOper=' || :NEW.NRNIVELGRUP;
            END IF;

            IF NVL(:OLD.NRPOSBOTGRUP,'') <> NVL(:NEW.NRPOSBOTGRUP,'') THEN
               V_DESC := V_DESC || ' PosBotOper=' || :NEW.NRPOSBOTGRUP;
            END IF;

            IF NVL(:OLD.NRMENUGRGRUP,'') <> NVL(:NEW.NRMENUGRGRUP,'') THEN
               V_DESC := V_DESC || ' NrMenu=' || :NEW.NRMENUGRGRUP;
            END IF;

            V_TIPO         := '2';
            V_ITPESQ       := :NEW.CDGRUPOPER||:NEW.CDSISTGRUP||:NEW.CDMENUITGRUP;
         END IF;
      ELSE
         IF :NEW.CDGRUPOPER IS NOT NULL THEN
            V_DESC := V_DESC || 'Oper=' || :NEW.CDGRUPOPER;
         END IF;

         IF :NEW.CDSISTGRUP IS NOT NULL THEN
            V_DESC := V_DESC || ' SisOper=' || :NEW.CDSISTGRUP;
         END IF;

         IF :NEW.CDMENUITGRUP IS NOT NULL THEN
            V_DESC := V_DESC || ' MnItOper=' || :NEW.CDMENUITGRUP;
         END IF;

         IF :NEW.DSCAPTIONGRU IS NOT NULL THEN
            V_DESC := V_DESC || ' DsCaptOper=' || :NEW.DSCAPTIONGRU;
         END IF;

         IF :NEW.DSBPLGRUP IS NOT NULL THEN
            V_DESC := V_DESC || ' DSBPLGRUP=' || :NEW.DSBPLGRUP;
         END IF;

         IF :NEW.NRTPMENUGRUP IS NOT NULL THEN
            V_DESC := V_DESC || ' TpMenuOper=' || :NEW.NRTPMENUGRUP;
         END IF;

         IF :NEW.NRATALHOGRUP IS NOT NULL THEN
            V_DESC := V_DESC || ' AtaOper=' || :NEW.NRATALHOGRUP;
         END IF;

         IF :NEW.NRNIVELGRUP IS NOT NULL THEN
            V_DESC := V_DESC || ' NivOper=' || :NEW.NRNIVELGRUP;
         END IF;

         IF :NEW.NRPOSBOTGRUP IS NOT NULL THEN
            V_DESC := V_DESC || ' PosBotOper=' || :NEW.NRPOSBOTGRUP;
         END IF;

         IF :NEW.NRMENUGRGRUP IS NOT NULL THEN
            V_DESC := V_DESC || ' NrMenu=' || :NEW.NRMENUGRGRUP;
         END IF;

         V_TIPO         := '1';
         V_ITPESQ       := :NEW.CDGRUPOPER||:NEW.CDSISTGRUP||:NEW.CDMENUITGRUP;
      END IF;
   END IF;
   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);

      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;
            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('MENUGRUPOP',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_GER_MENUGRUPOP','4.09.060'); END;
/
